from . import artist as artist, cbook as cbook, docstring as docstring, rcParams as rcParams
from ._enums import CapStyle as CapStyle, JoinStyle as JoinStyle
from .artist import Artist as Artist, allow_rasterization as allow_rasterization
from .cbook import STEP_LOOKUP_MAP as STEP_LOOKUP_MAP, ls_mapper as ls_mapper, ls_mapper_r as ls_mapper_r
from .markers import CARETDOWN as CARETDOWN, CARETDOWNBASE as CARETDOWNBASE, CARETLEFT as CARETLEFT, CARETLEFTBASE as CARETLEFTBASE, CARETRIGHT as CARETRIGHT, CARETRIGHTBASE as CARETRIGHTBASE, CARETUP as CARETUP, CARETUPBASE as CARETUPBASE, MarkerStyle as MarkerStyle, TICKDOWN as TICKDOWN, TICKLEFT as TICKLEFT, TICKRIGHT as TICKRIGHT, TICKUP as TICKUP
from .path import Path as Path
from .transforms import Bbox as Bbox, BboxTransformTo as BboxTransformTo, TransformedPath as TransformedPath
from typing import Any

def segment_hits(cx, cy, x, y, radius): ...

class Line2D(Artist):
    lineStyles: Any
    drawStyles: Any
    drawStyleKeys: Any
    markers: Any
    filled_markers: Any
    fillStyles: Any
    zorder: int
    def validCap(cls): ...
    def validJoin(cls): ...
    pickradius: Any
    ind_offset: int
    def __init__(self, xdata, ydata, linewidth: Any | None = ..., linestyle: Any | None = ..., color: Any | None = ..., marker: Any | None = ..., markersize: Any | None = ..., markeredgewidth: Any | None = ..., markeredgecolor: Any | None = ..., markerfacecolor: Any | None = ..., markerfacecoloralt: str = ..., fillstyle: Any | None = ..., antialiased: Any | None = ..., dash_capstyle: Any | None = ..., solid_capstyle: Any | None = ..., dash_joinstyle: Any | None = ..., solid_joinstyle: Any | None = ..., pickradius: int = ..., drawstyle: Any | None = ..., markevery: Any | None = ..., **kwargs) -> None: ...
    def contains(self, mouseevent): ...
    def get_pickradius(self): ...
    def set_pickradius(self, d) -> None: ...
    def get_fillstyle(self): ...
    stale: bool
    def set_fillstyle(self, fs) -> None: ...
    def set_markevery(self, every) -> None: ...
    def get_markevery(self): ...
    def set_picker(self, p) -> None: ...
    def get_window_extent(self, renderer): ...
    def set_data(self, *args) -> None: ...
    def recache_always(self) -> None: ...
    def recache(self, always: bool = ...) -> None: ...
    def set_transform(self, t) -> None: ...
    def draw(self, renderer) -> None: ...
    def get_antialiased(self): ...
    def get_color(self): ...
    def get_drawstyle(self): ...
    def get_linestyle(self): ...
    def get_linewidth(self): ...
    def get_marker(self): ...
    def get_markeredgecolor(self): ...
    def get_markeredgewidth(self): ...
    def get_markerfacecolor(self): ...
    def get_markerfacecoloralt(self): ...
    def get_markersize(self): ...
    def get_data(self, orig: bool = ...): ...
    def get_xdata(self, orig: bool = ...): ...
    def get_ydata(self, orig: bool = ...): ...
    def get_path(self): ...
    def get_xydata(self): ...
    def set_antialiased(self, b) -> None: ...
    def set_color(self, color) -> None: ...
    def set_drawstyle(self, drawstyle) -> None: ...
    def set_linewidth(self, w) -> None: ...
    def set_linestyle(self, ls) -> None: ...
    def set_marker(self, marker) -> None: ...
    def set_markeredgecolor(self, ec) -> None: ...
    def set_markerfacecolor(self, fc) -> None: ...
    def set_markerfacecoloralt(self, fc) -> None: ...
    def set_markeredgewidth(self, ew) -> None: ...
    def set_markersize(self, sz) -> None: ...
    def set_xdata(self, x) -> None: ...
    def set_ydata(self, y) -> None: ...
    def set_dashes(self, seq) -> None: ...
    def update_from(self, other) -> None: ...
    def set_dash_joinstyle(self, s) -> None: ...
    def set_solid_joinstyle(self, s) -> None: ...
    def get_dash_joinstyle(self): ...
    def get_solid_joinstyle(self): ...
    def set_dash_capstyle(self, s) -> None: ...
    def set_solid_capstyle(self, s) -> None: ...
    def get_dash_capstyle(self): ...
    def get_solid_capstyle(self): ...
    def is_dashed(self): ...

class _AxLine(Line2D):
    def __init__(self, xy1, xy2, slope, **kwargs) -> None: ...
    def get_transform(self): ...
    def draw(self, renderer) -> None: ...

class VertexSelector:
    axes: Any
    line: Any
    canvas: Any
    cid: Any
    ind: Any
    def __init__(self, line) -> None: ...
    def process_selected(self, ind, xs, ys) -> None: ...
    def onpick(self, event) -> None: ...

lineStyles: Any
lineMarkers: Any
drawStyles: Any
fillStyles: Any
